# What are some common Extensions?

In Periodic10 there are no restrictions on the naming convention for extensions, but they are typically prefixed with `periodicjs.ext`

* periodicjs.ext.packagecloud 
  * An extension for using packagecloud to upload files to a numerous cloud storage service providers (e.g. Amazon S3).
* periodicjs.ext.passport 
  * An extension for using passport to handle user authentication via multple authentication strategies (OAuth, OAuth2, Social Signin [Facebook, Twitter, Google, etc], Single Sign-On).
* periodicjs.ext.oauth2client 
  * The ability to authenticate users with OAuth2.
* periodicjs.ext.oauth2server 
  * An extension enabling your application to serve as an OAuth2 server.
* periodicjs.ext.reactadmin 
  * A React based Single Page Application Admin UI for your web application, with auto-generated views based off of your database models.
* periodicjs.ext.user_access_control 
  * An extension for providing granular ACL within your application
* periodicjs.ext.basicadmin 
  * A very basic admin ui based off of your database models.
* periodicjs.ext.dbseed 
  * An export/import data extension for loading data into your application

NEXT: [ Installing and Removing Extensions ](https://github.com/repetere/periodicjs/blob/master/doc/extensions/05-installing-and-removing-extensions.md)